﻿
libname xu 'p:\vsd_method\q0_50_q1_80';

%let dtname=xu.a_n12_b69_P0_50_p1_80_;
%macro new_sim (sim_start,numsim,Nsubj,studyend,riskwindow,alpha,beta,true_confirm_rate_S0,true_confirm_rate_S1,true_confirm_rate_M0,true_confirm_rate_M1,
true_confirm_rate_L0,true_confirm_rate_L1,chart_review_p_S0,chart_review_p_S1,chart_review_p_M0,chart_review_p_M1,chart_review_p_L0,chart_review_p_L1);
%do ii=&sim_start %to &numsim;

data cohort;
 seed=1021231+&ii;

 siteN10=0.1*&Nsubj;
 siteN40=0.4*&Nsubj;  *this will give 10%, 30% and 60% sample size for s, m and l sites;

do id=1 to &Nsubj;

if id=<siteN10 then do;
 site='S';
end;

else if id=<siteN40 then do;
 site='M';
end;

else do;
 site='L';
end;

   vacdays=1+round(&studyend*ranuni(seed));

   if 10=<vacdays =< (360-&riskwindow) then do; **vac between 10-318 days;
   do int=1 to 3; 
	   if int=1 then do;
         start=1; end=vacdays-1; pt=vacdays-1; risk=0;  output;
       end;
	   else if int=2 then do;
         start=vacdays; end=vacdays+&riskwindow-1; pt=&riskwindow; risk=1; output;
	   end;
	   else if int=3 then do;
         start=vacdays+&riskwindow; end=360; pt=end-start+1; risk=0; output;
	   end;
    end;
    end;

end;

run;

data simcase;
 set cohort;

     if site='S' and risk=0 then true_confirm_rate=&true_confirm_rate_S0;
else if site='S' and risk=1 then true_confirm_rate=&true_confirm_rate_S1;

else if site='M' and risk=0 then true_confirm_rate=&true_confirm_rate_M0;
else if site='M' and risk=1 then true_confirm_rate=&true_confirm_rate_M1;

else if site='L' and risk=0 then true_confirm_rate=&true_confirm_rate_M0;
else if site='L' and risk=1 then true_confirm_rate=&true_confirm_rate_M1;

 mu=exp(&alpha+risk*&beta+log(pt))/true_confirm_rate;  **insert comfirmation rate;
 y=ranPOI(seed,mu);
run;


data tmpid;
keep id;
 set simcase;
 if y>=1 then output;
run;

proc sort data=simcase;
by id;
proc sort data=tmpid nodupkey;
by id;
run;

data dtname&ii;
 merge tmpid(in=m) simcase;
 by id;
 logpt=log(pt);
 if y>=1 then caseday=start+round((end-start)*(ranuni(seed)));  **Only one case in the end;
 else caseday=.;
 if m=1;
 run;


data allsites1;
 set dtname&ii;

     if site='S' and risk=0 then chart_review_p=&chart_review_p_S0;
else if site='S' and risk=1 then chart_review_p=&chart_review_p_S1;
else if site='M' and risk=0 then chart_review_p=&chart_review_p_M0;
else if site='M' and risk=1 then chart_review_p=&chart_review_p_M1;
else if site='L' and risk=0 then chart_review_p=&chart_review_p_L0;
else if site='L' and risk=1 then chart_review_p=&chart_review_p_L1;

if y=1 and chart_review_p=1 then chart_reviewed=1;
else if y=1 and chart_review_p<1 then chart_reviewed=ranbin (seed, 1,chart_review_p);

if chart_reviewed=1 then confirmed=ranbin (seed, 1,true_confirm_rate);
run;


proc sort data=allsites1;
by id int;
run;

  data allsites2;
  drop int risk y pt chart_reviewed ;
   array yary[3] y0before y1 y0after;  *y0before for non-risk window before vac, 1 for riskwindow;
   array ptary[3] pt0before pt1 pt0after;

   do i=1 to 3 until(last.id);
    set allsites1;
	by id;
	yary[i]=y;
	ptary[i]=pt;
   end;

   if y1=. and y0after=. then delete;
run;

data confirmation;
keep id confirmed;
 set allsites1;
 if y=1;
run;

data confirmation_allsites2;
 merge allsites2 confirmation;
 by id;
 if y1=1 then exposed_status=1;
 else exposed_status=0;

 if confirmed=. then intval=0;
 else intval=1;

 Lsite=(site='L');
 Msite=(site='M');

 run;

*model 1: without correction;
ods trace off;
proc nlmixed data=confirmation_allsites2;
  parm b=0.2;

    if y0after=. then do;
	   mu0before=pt0before/(pt0before+pt1*exp(b)); 
	   mu1=(pt1*exp(b))/(pt0before+pt1*exp(b));
	   c_joint_like=log((mu0before**y0before)*(mu1**y1));
    end;

    else do;
	   mu0before=pt0before/(pt0before+pt1*exp(b)+pt0after); 
	   mu0after=pt0before/(pt0before+pt1*exp(b)+pt0after); 
	   mu1=(pt1*exp(b))/(pt0before+pt1*exp(b)+pt0after);
	   c_joint_like=log((mu0before**y0before)*(mu1**y1)*(mu0after**y0after));
    end;

	model y1~general (c_joint_like);
   ods output ParameterEstimates=without_correction0;
run;


data without_correction1;
keep dt Estimate_without_cor Stderr_without_cor DF_without_cor tValue_without_cor Probt_without_cor;
 set without_correction0;
Estimate_without_cor=Estimate;
Stderr_without_cor=StandardError;
DF_without_cor=df;
tValue_without_cor=tValue;
Probt_without_cor=Probt;
 dt=&ii;
run;


*Model 2: just confirmed case;
ods trace off;
proc nlmixed data=confirmation_allsites2;
where confirmed=1;
  parm b=0.2;

    if y0after=. then do;
	   mu0before=pt0before/(pt0before+pt1*exp(b)); 
	   mu1=(pt1*exp(b))/(pt0before+pt1*exp(b));
	   c_joint_like=log((mu0before**y0before)*(mu1**y1));
    end;

    else do;
	   mu0before=pt0before/(pt0before+pt1*exp(b)+pt0after); 
	   mu0after=pt0before/(pt0before+pt1*exp(b)+pt0after); 
	   mu1=(pt1*exp(b))/(pt0before+pt1*exp(b)+pt0after);
	   c_joint_like=log((mu0before**y0before)*(mu1**y1)*(mu0after**y0after));
    end;

	model y1~general (c_joint_like);
   ods output ParameterEstimates=confirmedcase0;
run;

data confirmedcase1;
keep dt Estimate_confirmedcase Stderr_confirmedcase DF_confirmedcase tValue_confirmedcase Probt_confirmedcase;
 set confirmedcase0;
Estimate_confirmedcase=Estimate;
Stderr_confirmedcase=StandardError;
DF_confirmedcase=df;
tValue_confirmedcase=tValue;
Probt_confirmedcase=Probt;
 dt=&ii;
run;



proc sort data=without_correction1;
by dt;

proc sort data=confirmedcase1;
by dt;


data all_results;
 merge without_correction1 confirmedcase1;
 by dt;
run;

*DM log 'clear';
proc append base=xu.a_n12_beta_069_p0_50_p1_80 new=all_results force;run;  ***need change!!!!!!;
*DM output 'clear';
%end;
%mend new_sim;


data xu.a_n12_beta_069_p0_50_p1_80;
input dt Estimate_without_cor Stderr_without_cor DF_without_cor tValue_without_cor Probt_without_cor Estimate_confirmedcase Stderr_confirmedcase DF_confirmedcase tValue_confirmedcase Probt_confirmedcase;
cards;
%new_sim(sim_start=1,numsim=1000,Nsubj=100000, studyend=360, riskwindow=42, alpha=-12, beta=0.693, true_confirm_rate_S0=0.5,true_confirm_rate_S1=0.8,true_confirm_rate_M0=0.5,true_confirm_rate_M1=0.8,true_confirm_rate_L0=0.5,true_confirm_rate_L1=0.8,chart_review_p_S0=1,chart_review_p_S1=1,chart_review_p_M0=1.0,chart_review_p_M1=1.0,chart_review_p_L0=1.0,chart_review_p_L1=1.0);
run;


proc means data= xu.a_n12_beta_069_p0_50_p1_80;
 var Estimate_without_cor Estimate_confirmedcase Stderr_without_cor Stderr_confirmedcase;
run;

/*
Variable                    N           Mean        Std Dev        Minimum        Maximum
 -----------------------------------------------------------------------------------------
 Estimate_without_cor     1000      0.2218486      0.1448777     -0.2201395      0.6000863
 Estimate_confirmedcase   1000      0.6890669      0.1703504      0.1713235      1.1380434
 Stderr_without_cor       1000      0.1455549      0.0085300      0.1214231      0.1754443
 Stderr_confirmedcase     1000      0.1700835      0.0105980      0.1439687      0.2042112
 ----------------------------------------------------------------------------------------

*/


data power;
 set xu.a_n12_beta_069_p0_50_p1_80;

if Probt_without_cor<0.05 then reject_without_cor=1;
else reject_without_cor=0;

if Probt_confirmedcase<0.05 then reject_confirmedcase=1;
else reject_confirmedcase=0;

run;


proc freq data=power;
 tables reject_without_cor reject_confirmedcase;
run;

/*
          reject_without_                             Cumulative    Cumulative
                        cor    Frequency     Percent     Frequency      Percent
           ---------------------------------------------------------------------
                          0         642       64.20           642        64.20
                          1         358       35.80          1000       100.00


                    reject_                             Cumulative    Cumulative
              confirmedcase    Frequency     Percent     Frequency      Percent
           ---------------------------------------------------------------------
                          0          34        3.40            34         3.40
                          1         966       96.60          1000       100.00
*/
